VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsLumpDir"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit
Private Lumps As New Collection

Public Function AddEntry(ByVal LName As String, ByVal LSize As Long, Optional LumpPosition As Long) As clsLumpDirEntry
Dim nEnt As clsLumpDirEntry, LastEntry As clsLumpDirEntry
If Not Lumps.Count = 0 Then Set LastEntry = Lumps(Lumps.Count)
Set nEnt = New clsLumpDirEntry
If LastEntry Is Nothing Then
nEnt.LumpPosition = 12
Else
If nEnt.LumpSize > 0 Then
nEnt.LumpPosition = LastEntry.LumpPosition + LastEntry.LumpSize
End If
End If
nEnt.LumpName = LName
nEnt.LumpSize = LSize
If LumpPosition > 11 Then
nEnt.LumpPosition = LumpPosition
End If
Lumps.Add nEnt
Set AddEntry = nEnt
End Function

Public Sub RemoveEntry(ByVal Index As Long)
Lumps.Remove Index
End Sub

Public Sub Clear()
Dim m_lngLoop As Long
For m_lngLoop = 1 To Count
RemoveEntry 1
Next
End Sub
Public Property Get RetEntry(ByVal Index As Long) As clsLumpDirEntry
Attribute RetEntry.VB_UserMemId = 0
Attribute RetEntry.VB_MemberFlags = "240"
Set RetEntry = Lumps(Index)
End Property

Public Property Get Count() As Long
Count = Lumps.Count
End Property

Public Sub ReCalc()
Dim DirStart As Long, PlacementStart As Long, m_lngLoop As Long, WadDirStart As Long
DirStart = 12
PlacementStart = 12
For m_lngLoop = 1 To Count
'Stop
DirStart = DirStart + RetEntry(m_lngLoop).LumpSize
If RetEntry(m_lngLoop).LumpSize > 0 Then
RetEntry(m_lngLoop).LumpPosition = PlacementStart
Else
RetEntry(m_lngLoop).LumpPosition = 0
End If
PlacementStart = PlacementStart + RetEntry(m_lngLoop).LumpSize
Next
WadDirStart = DirStart
End Sub
